/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem;

import de.steamwar.bausystem.config.BauServer;
import de.steamwar.bausystem.features.world.BauMemberUpdate;
import de.steamwar.sql.BauweltMember;
import de.steamwar.sql.SteamwarUser;
import lombok.AllArgsConstructor;
import org.bukkit.entity.Player;

import java.util.HashSet;
import java.util.Set;
import java.util.function.Predicate;

@AllArgsConstructor
public enum Permission {

    OWNER(bauweltMember -> false),
    SUPERVISOR(bauweltMember -> {
        return bauweltMember.isSupervisor();
    }),
    BUILD(bauweltMember -> {
        if (isTempOnlySpectator(bauweltMember)) return false;
        return bauweltMember.isBuild() || SUPERVISOR.permissionPredicate.test(bauweltMember);
    }),
    /**
     * Only used for {@link BauMemberUpdate}
     */
    REAL_SPECTATOR(bauweltMember -> {
        return !bauweltMember.isBuild() && !bauweltMember.isSupervisor();
    }),
    /**
     * Primarily used for {@link de.steamwar.bausystem.linkage.specific.GuiItem}
     */
    MEMBER(bauweltMember -> {
        return true;
    });

    private static final Set<Integer> TEMP_ONLY_SPECTATOR = new HashSet<>();

    private static boolean isTempOnlySpectator(BauweltMember bauweltMember) {
        return TEMP_ONLY_SPECTATOR.contains(bauweltMember.getMemberID());
    }
    
    public static boolean isTempOnlySpectator(Player player) {
        return TEMP_ONLY_SPECTATOR.contains(SteamwarUser.get(player.getUniqueId()).getId());
    }

    public static void forceOnlySpectator(Player player) {
        TEMP_ONLY_SPECTATOR.add(SteamwarUser.get(player.getUniqueId()).getId());
        BauMemberUpdate.baumemberUpdate();
    }

    /**
     * Only used by {@link BauMemberUpdate}
     */
    public static void removeForceOnlySpectator(Player player) {
        TEMP_ONLY_SPECTATOR.remove(SteamwarUser.get(player.getUniqueId()).getId());
    }

    private final Predicate<BauweltMember> permissionPredicate;

    public boolean hasPermission(BauweltMember bauweltMember) {
        if (bauweltMember == null) return false;
        return permissionPredicate.test(bauweltMember);
    }

    public boolean hasPermission(Player member) {
        if (SteamwarUser.get(member.getUniqueId()).getId() == BauServer.getInstance().getOwnerID()) {
            return this != REAL_SPECTATOR;
        }
        BauweltMember bauweltMember = BauweltMember.getBauMember(BauServer.getInstance().getOwner(), member.getUniqueId());
        if (bauweltMember == null) return this == REAL_SPECTATOR;
        return permissionPredicate.test(bauweltMember);
    }
}